org.encog.ml.prg.extension

## Enum EncogOpcodeRegistry

- java.lang.Object
- - java.lang.Enum<EncogOpcodeRegistry>
  - - org.encog.ml.prg.extension.EncogOpcodeRegistry

- All Implemented Interfaces:
    Serializable, Comparable<EncogOpcodeRegistry>

      public enum EncogOpcodeRegistry
      extends Enum<EncogOpcodeRegistry>

  Holds all known EPL opcodes. Extension programs should add new opcodes here. The FunctionFactory selects a subset of opcodes from here that will be run. An opcode is identified by its name, and the number of parameters it accepts. It is okay to add an opcode multiple times, the new opcode replaces the previous.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `INSTANCE`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(ProgramExtensionTemplate ext)` Add an opcode.
    `static String` | `createKey(String functionName, int argCount)` Construct a lookup key for the hash map.
    `Collection<ProgramExtensionTemplate>` | `findAllOpcodes()`
    `ProgramExtensionTemplate` | `findOpcode(String name, int args)` Find the specified opcode.
    `static EncogOpcodeRegistry` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static EncogOpcodeRegistry[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### INSTANCE

          public static final EncogOpcodeRegistry INSTANCE

  - ### Method Detail

    - #### values

          public static EncogOpcodeRegistry[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (EncogOpcodeRegistry c : EncogOpcodeRegistry.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static EncogOpcodeRegistry valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### createKey

          public static String createKey(String functionName,
                         int argCount)

      Construct a lookup key for the hash map.
      Parameters:
        `functionName` - The name of the opcode.
        `argCount` - The number of parameters this opcode accepts.
      Returns:
        Return the string key.

    - #### add

          public void add(ProgramExtensionTemplate ext)

      Add an opcode. User programs should add opcodes here.
      Parameters:
        `ext` - The opcode to add.

    - #### findAllOpcodes

          public Collection<ProgramExtensionTemplate> findAllOpcodes()

    - #### findOpcode

          public ProgramExtensionTemplate findOpcode(String name,
                                            int args)

      Find the specified opcode.
      Parameters:
        `name` - The name of the opcode.
        `args` - The number of arguments.
      Returns:
        The opcode if found, null otherwise.

Copyright © 2014. All Rights Reserved.